package x33eja.model;

import java.io.Serializable;
import java.util.List;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

@Entity
@DiscriminatorValue("student")
@NamedQueries(@NamedQuery(name="Student.findAll",query="SELECT s FROM Student s ORDER BY s.surname ASC, s.firstName ASC"))
public class Student extends Person implements Serializable {

    @ManyToMany
    private List<Course> mEnrolledIn;

    @ManyToOne
    private Teacher mHasSupervisor;

    public List<Course> getEnrolledIn () {
        return mEnrolledIn;
    }

    public void setEnrolledIn (List<Course> val) {
        this.mEnrolledIn = val;
    }

    public Teacher getHasSupervisor () {
        return mHasSupervisor;
    }

    public void setHasSupervisor (Teacher val) {
        this.mHasSupervisor = val;
    }
}

