package x33eja.sb;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import x33eja.model.Course;
import x33eja.model.Student;
import x33eja.model.Teacher;

@Stateless
public class StudentSessionBean implements StudentSessionLocal {

    @PersistenceContext
    private EntityManager em;

    public List<Course> getNotEnrolledCoursesForCurrent() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Map<Student, Long> getStudentsWithCourseCount() {
        final Map<Student, Long> map = new LinkedHashMap<Student, Long>();

        final List<Object[]> result = (List<Object[]>) em.createQuery("SELECT p, count(e) FROM Student p LEFT JOIN p.mEnrolledIn e GROUP BY p ORDER BY p.surname, p.firstName").getResultList();

        for (final Object[] o : result) {
            map.put((Student) o[0], (Long) o[1]);
        }

        return map;
    }

    public void saveStudent(Student student) {
        student = em.merge(student);
        em.persist(student);
    }

    public void addCourse(Course course) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public List<Student> getAllStudents() {
        return (List<Student>) em.createNamedQuery("Student.findAll").getResultList();
    }

    public List<Teacher> getAllTeachers() {
        return (List<Teacher>) em.createNamedQuery("Teacher.findAll").getResultList();
    }

    public Teacher getTeacherWithId(String id) {
        try {
            return em.find(Teacher.class, Integer.parseInt(id));
        } catch (java.lang.NumberFormatException e) {
            e.printStackTrace();
        }
        return null;
    }
}
