package cz.cvut.x33eja.back;

import java.util.ArrayList;
import java.util.List;
import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.faces.model.SelectItem;
import x33eja.model.Student;
import x33eja.model.Teacher;
import x33eja.sb.StudentSessionLocal;

/**
 *
 * @author valekf1
 */
public class StudentsBack {

    @EJB
    StudentSessionLocal ssl;
    private DataModel allStudentsModel;
    private Student student = null;

    /**
     * Dokud nebyl pouzit DataModel pro upravu studenta, byla tato metoda public
     */
    private List<Student> getAllStudents() {
        return ssl.getAllStudents();
    }

    /**
     * Vyber studenta pro editaci
     */
    public String editStudent() {
        student = (Student) allStudentsModel.getRowData();
        return "edit-student";
    }

    // Mozne metodu upravit a po uspesnem ulozeni presmerovat na seznam studentu
    public void saveStudent() {
        ssl.saveStudent(student);

        // Zobrazeni zpravy o uspesnem ulozeni
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage("Successfully saved"));
    }

    public String newStudent() {
        student = new Student();
        return "edit-student";
    }

    public String list() {
        return "list-students";
    }

    /**
     * @return the student
     */
    public Student getStudent() {
        return student;
    }

    /**
     * @param student the student to set
     */
    public void setStudent(Student student) {
        this.student = student;
    }

    /**
     * @return the allStudentsModel
     */
    public DataModel getAllStudentsModel() {
        allStudentsModel = new ListDataModel(getAllStudents());
        return allStudentsModel;
    }

    /**
     * @param allStudentsModel the allStudentsModel to set
     */
    public void setAllStudentsModel(DataModel allStudentsModel) {
        this.allStudentsModel = allStudentsModel;
    }

    /**
     * SelectItem obsahuje objekt Teacher jako hodnotu a popisek se jmeny.
     * Misto objektu je mozne pouzivat i jeho ID, pak by nebylo nutne pouzit konvertor,
     * ale komplikovalo by se setovani objektu Teacher jako hasSupervisor
     * (musel by se pouzit dalsi objekt v backing bean a pro toto id z EJB vrstvy
     * ziskat odpovidajici objekt)
     * @return list of SelectItem
     */
    public List<SelectItem> getAllTeachersSelectList() {
        List<SelectItem> items = new ArrayList<SelectItem>();
        for (Teacher t : ssl.getAllTeachers()) {
            items.add(new SelectItem(t, t.getSurname() + " " + t.getFirstName()));
        }
        return items;
    }
}
