package cz.cvut.x33eja.util;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

/**
 * Priklad jednoducheho validatoru. Validator na delku je vhodnejsi pouzit primo z JSF,
 * nicmene pro slozitejsi pripady je mozne implementovat obdobnevalidator vlastni.
 */
public class BirthdateValidator implements Validator {

    private static final int MAX_LENGTH = 10;

    public void validate(FacesContext context, UIComponent component, Object value) throws ValidatorException {
        String n = String.valueOf(value);
        if ((n == null) || (n.length() == 0)) {
            return;
        }
        boolean ok = n.length() < MAX_LENGTH;
        if (!ok) {
            throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "Too long number", null));
        }
    }
}
