package cz.cvut.x33eja.util;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import x33eja.model.Teacher;
import x33eja.sb.StudentSessionLocal;

public class TeacherConverter implements Converter {

    public Object getAsObject(FacesContext context, UIComponent component, String value) {
        return lookupStudentSessionBean().getTeacherWithId(value);
    }

    public String getAsString(FacesContext context, UIComponent component, Object value) {
        return String.valueOf(((Teacher) value).getBirthNumber());
    }

    private StudentSessionLocal lookupStudentSessionBean() {
        try {
            Context c = new InitialContext();
            return (StudentSessionLocal) c.lookup("java:comp/env/StudentSessionBean");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }
}
