
<%@page contentType="text/html" pageEncoding="UTF-8"%>

<%@taglib prefix="f" uri="http://java.sun.com/jsf/core"%>
<%@taglib prefix="h" uri="http://java.sun.com/jsf/html"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<f:view>
    <html>
        <head>
            <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
            <title>Edit Student</title>
        </head>
        <body>
            <h1><h:outputText value="Edit Student"/></h1>
            <h:form prependId="false">
                <h:commandLink action="#{students.list}" value="All students" immediate="true"/>

                <h:panelGrid columns="2">
                    <h:outputText value="Birth number:" />
                    <h:panelGroup>
                        <h:inputText id="birth" value="#{students.student.birthNumber}" required="true" disabled="#{!(students.student.birthNumber==0)}">
                            <f:validator validatorId="BirthdateValidator" />
                        </h:inputText>
                        <h:message for="birth" />
                    </h:panelGroup>
                    <h:outputText value="First name:" />
                    <h:inputText value="#{students.student.firstName}" />
                    <h:outputText value="Surname:" />
                    <h:inputText value="#{students.student.surname}" />
                    <h:outputText value="Superviser:" />
                    <h:selectOneListbox value="#{students.student.hasSupervisor}" size="1">
                        <f:selectItems value="#{students.allTeachersSelectList}" />
                        <f:converter converterId="TeacherConverter" />
                    </h:selectOneListbox>
                </h:panelGrid>
                <h:commandButton action="#{students.saveStudent}" value="Save"/>
                <h:messages />
            </h:form>
        </body>
    </html>
</f:view>
